--- old/usr/src/uts/common/fs/smbclnt/smbfs/smbfs_client.c	2012-08-18 10:48:42.207928036 +0800
+++ new/usr/src/uts/common/fs/smbclnt/smbfs/smbfs_client.c	2012-08-18 10:48:41.904710318 +0800
@@ -124,7 +124,6 @@
 void
 smbfs_purge_caches(struct vnode *vp)
 {
-#if 0	/* not yet: mmap support */
 	/*
 	 * NFS: Purge the DNLC for this vp,
 	 * Clear any readdir state bits,
@@ -136,9 +135,8 @@
 	 * Flush the page cache.
 	 */
 	if (vn_has_cached_data(vp)) {
-		(void) VOP_PUTPAGE(vp, (u_offset_t)0, 0, B_INVAL, cr, NULL);
+		(void) VOP_PUTPAGE(vp, (u_offset_t) 0, 0, B_INVAL, np->r_cred, NULL);
 	}
-#endif	/* not yet */
 }
 
 /*
@@ -294,12 +292,11 @@
 		newsize = DEV_BSIZE;
 
 	if (np->r_size != newsize) {
-#if 0	/* not yet: mmap support */
-		if (!vn_has_cached_data(vp) || ...)
-			/* XXX: See NFS page cache code. */
-#endif	/* not yet */
-		/* OK to set the size. */
-		np->r_size = newsize;
+		if (!vn_has_cached_data(vp) 
+		    || (!(np->r_flags & RDIRTY)&& np->r_count == 0)) {
+			/* OK to set the size. */
+			np->r_size = newsize;
+		}
 	}
 
 	/* NFS: np->r_flags &= ~RWRITEATTR; */
